-- 神秘信笺
Lua_XinQianWindow = class("Lua_XinQianWindow", Lua_FullSizeWindow)
function Lua_XinQianWindow:ctor(p)
	self:superCall("ctor", false, true, 3500, false, false, false);

	self.windowName = "Lua_XinQianWindow";
	self.skinName = "XinQianWindow_skin";
end

function Lua_XinQianWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.desTipsLab.text = LanUtil.getValue(144938);

	self.avo = DataCenter.OperationalActivitiesData:getActivitiesByType(1016, 0);
	if self.avo == nil then
		self:hide();
		return;
	end
	DataCenter.OperationalActivitiesData:sGetOperationalActivities(self.avo.act_index, 1016);

	self.rewardItem = Lua_RewardDragItem.new(self.content, 680);
	self.rewardItem.pivot = 2;
	self.rewardItem:setDepth(5);
	self.rewardItem:setLocation(172, 6, 0);

	self.btnEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/eu1_003", "eu1_003", 337, -275);		
	self.btnEffect.circulate = true;
	self.btnEffect:SetRenderQueue(self.titleTxt, 5, 2, false);

	self.cancelBtn:addClickFuntion(self, self.hide);
	self.subBtn:addClickFuntion(self, self.onSubClick);
	self.tipsIcon:addClickFuntion(self, self.onRuleClick);

	self:addTimer("Lua_XinQianWindow", 0.5, self, self.onCountDown);

	self:addLuaEvent("UPDATE_ONEPANEL_DATA", self, self.onActInfo);
end

function Lua_XinQianWindow:onCountDown()
	if self.leftTime ~= nil then
		local pt = getTime() - self.startTime;
		local lt = self.leftTime - pt;
		if lt >= 0 then
			lt = math.floor(lt);
			if self.curStepData.arrive > self.curStepData.drawed then
				self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(122587), TimeTransform.getInstance():transSeconds6(lt, false, true));
			else
				self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(122583), TimeTransform.getInstance():transSeconds6(lt, false, true));
			end
		else
			self.timeTxt.text = LanUtil.getValue(122584);
		end
	end
end

function Lua_XinQianWindow:onActInfo(msg)
	if msg.act_detail.act_index == self.avo.act_index and 1016 == msg.act_detail.first_type then
		self.actDetail = msg.act_detail;
		
		self.curStep = self.actDetail.cur_index; -- 当前档次
		if self.curStep == -1 then
			self:hide();
			return;
		end

		self.curStepData = self.actDetail.reward_info[self.curStep + 1];
		if self.curStepData == nil then
			self:hide();
			return;
		end

		self.titleTxt.text = self.curStepData.title;
		self.contentTxt.text = self.curStepData.content;
		if getLanType() == 2 then
			self.nowTxt.text = self.curStepData.double_cont[1]; -- 现价
			self.oldTxt.text = self.curStepData.double_cont[5]; -- 原价
			self.rechargeMoney = tonumber(self.curStepData.double_cont[1]);
		else
			self.nowTxt.text = self.curStepData.cond[1]; -- 现价
			self.oldTxt.text = self.curStepData.cond[5]; -- 原价
			self.rechargeMoney = tonumber(self.curStepData.cond[1]);
		end

		local effectDic = {};
		for i,v in ipairs(self.curStepData.spec_effect_item) do
			effectDic[tonumber(v)] = 1;
		end

		-- 特殊显示元宝道具，因为走充值流程，服务端不发物品（避免道具插入背包）策划需求，显示到最前面
		local tvo;
		local rsList = Array();
		local cond = tonumber(self.curStepData.cond[4]);
		if cond ~= nil and cond ~= 0 then
			tvo = Lua_ToolVo.createToolVo(209000003, cond, 0);
			tvo.roundEffect = true;
			tvo.bShowItemBg = true;
			rsList:add(tvo);
		end

		for i,v in ipairs(self.curStepData.reward_set) do
			tvo = Lua_ToolVo.createToolVo(v.id, 1, 0);
			tvo:fromServer(v);
			tvo.roundEffect = effectDic[v.id] == 1;
			tvo.bShowItemBg = true;
			rsList:add(tvo);
		end
		self.rewardItem:setRewardByArray(rsList);

		local nowServerTime = tonumber(tostring(GlobalVar.cur_tick));
		local stop_tick = tonumber(self.actDetail.stop_tick);
		self.leftTime = stop_tick - nowServerTime;
		self.startTime = getTime();

		if self.curStepData.arrive > self.curStepData.drawed then
			self.subBtn.label = LanUtil.getValue(122527);

			self.btnEffect:setEnable(false);
			self.redIcon:setEnable(true);
		else
			self.subBtn.label = LanUtil.getValue(122585);

			self.btnEffect:setEnable(true);
			self.redIcon:setEnable(false);
		end
	end
end

function Lua_XinQianWindow:onSubClick(o)
	if self.lastClickTime ~= nil and getTime() - self.lastClickTime < 0.5 then
		return;
	end
	self.lastClickTime = getTime();

	-- 可领取
	if self.curStepData.arrive > self.curStepData.drawed then
		local cmd = ProtoPublic_pb.Proto11400008();
		cmd.act_index = self.avo.act_index;
		cmd.reward_index = self.curStep;
		cmd.reward_num = 1;
		sendMsg(11400008,cmd);
		self:hide();
	else
		local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
		if sceneConfig.kuafu_map == 1 then
			DataCenter.moneyData:kuaFuLimit();
			return;
		end
		DataCenter.sdkInterface:PointOut(0, tonumber(self.rechargeMoney), 1003);
	end
end

function Lua_XinQianWindow:onRuleClick(o)
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, self.actDetail.content);
end

function Lua_XinQianWindow:dispose()
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end
	if self.btnEffect ~= nil then
		self.btnEffect:dispose();
		self.btnEffect = nil;
	end

	self:superCall("dispose");
end